Subject: Re: libbpf distro packaging

From: Jiri Olsa <[email-masked]>
Date: Tue, 10 Mar 2020 18:49:38 +0100

On Tue, Mar 10, 2020 at 10:18:12AM -0700, Julia Kartseva wrote:
> 
> 
> On 3/10/20 7:57 AM, Jiri Olsa wrote:
> > On Thu, Mar 05, 2020 at 03:18:12PM +0100, Jiri Olsa wrote:
> > 
> > so I did some more checking and libbpf is automatically pulled into
> > centos 8, it's just at the moment there's some bug preventing that.. 
> > it is going to be fixed shortly ;-)
> > 
> > as for centos 7, what is the target user there? which version of libbpf
> > would you need in there?
> > 
> > jirka
> >
> Hi, that's great news!
> Nothing prevents us from having the latest v0.0.7 [1] in CentOS 7 :)

that's just half true.. while libbpf is ok, libbpf-devel needs uapi
headers to define all the stuff that's used in libbpf's headers

  Example:
	$ echo "#include <bpf/xsk.h>" | gcc -x c - 
	In file included from <stdin>:1:
	/usr/include/bpf/xsk.h: In function ‘xsk_ring_prod__needs_wakeup’:
	/usr/include/bpf/xsk.h:82:21: error: ‘XDP_RING_NEED_WAKEUP’ undeclared (first use in this function)
	   82 |  return *r->flags & XDP_RING_NEED_WAKEUP;
	      |                     ^~~~~~~~~~~~~~~~~~~~
	/usr/include/bpf/xsk.h:82:21: note: each undeclared identifier is reported only once for each function it appears in
	/usr/include/bpf/xsk.h: In function ‘xsk_umem__extract_addr’:
	/usr/include/bpf/xsk.h:173:16: error: ‘XSK_UNALIGNED_BUF_ADDR_MASK’ undeclared (first use in this function)
	  173 |  return addr & XSK_UNALIGNED_BUF_ADDR_MASK;
	      |                ^~~~~~~~~~~~~~~~~~~~~~~~~~~
	/usr/include/bpf/xsk.h: In function ‘xsk_umem__extract_offset’:
	/usr/include/bpf/xsk.h:178:17: error: ‘XSK_UNALIGNED_BUF_OFFSET_SHIFT’ undeclared (first use in this function)
	  178 |  return addr >> XSK_UNALIGNED_BUF_OFFSET_SHIFT;
	      |                 ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

I'll need to check the state of rhel7 kernel headers, but that was
very early backport and I think headers are far behind

jirka

> Can updates for CentOS 7 and 8 be synced so the have the same libbpf version?
> 
> [1] https://github.com/libbpf/libbpf/releases/tag/v0.0.7
>